<template>
  <div class="gp-timeline-entry">
    <rui-icon v-if="!hideIcon" :name="icon" class="gp-timeline-entry__icon" />

    <div class="gp-timeline-entry__wrapper">
      <div class="-flex -gap">
        <h5 v-if="title" class="gp-timeline-entry__title">{{ title }}</h5>

        <rui-button v-if="commentsSubject"
                    icon="chat"
                    size="small"
                    :active="showComments"
                    @click="toggleComments">
          {{ commentsSubject.commentsCount }}
        </rui-button>

        <div class="-flex--grow">
          <div class="gp-timeline-entry__subject">
            <rui-icon :name="subjectIcon" class="-text--color-mute" />
            <small>{{ subject }}</small>
          </div>
        </div>

        <div v-if="$slots.actions">
          <rui-toolbar>
            <!-- @slot Optional actions -->
            <slot name="actions" />
          </rui-toolbar>
        </div>
      </div>

      <div class="gp-timeline-entry__body" :class="showComments ? 'gp-timeline-entry__body--with-comments' : ''">
        <div v-if="!isSlotEmpty($slots.default) || showComments" class="gp-timeline-entry__content">
          <!-- @slot Entry content -->
          <slot />
          <rui-empty v-if="isSlotEmpty($slots.default) && showComments"
                     class="-md-l:hidden"
                     :content="$t('js.timeline.empty_entry')"
                     small
                     inline />
        </div>

        <div v-if="commentsShownOnce" v-show="showComments" class="gp-timeline-entry__comments">
          <gp-comments-list :subject="commentsSubject" auto-load />
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import RuiButton from '@experiments-labs/rise_ui/src/components/Button/Button.vue'
import RuiEmpty from '@experiments-labs/rise_ui/src/components/DataDisplay/Empty/Empty.vue'
import RuiIcon from '@experiments-labs/rise_ui/src/components/Icon/Icon.vue'
import RuiToolbar from '@experiments-labs/rise_ui/src/components/Toolbar/Toolbar.vue'
import GpCommentsList from '../Comments/List.vue'

import { isSlotEmpty } from '../../../tools/IsSlotEmpty'

import Task from '../../../classes/models/Task'
import Observation from '../../../classes/models/Observation'

/**
 * Displays a timeline entry with comments.
 *
 * @preset default { "props": { "icon": "pencil", "subject": "The large patch", "subjectIcon": "polygon", "title": "Sowed some cabbage today." } }
 */
export default {
  name: 'GpTimelineEntry',
  components: { RuiEmpty, GpCommentsList, RuiButton, RuiToolbar, RuiIcon },
  props: {
    /** Icon name for the entry */
    icon: { required: false, type: String, default: 'asterisk' },
    /** Whether to hide the big icon */
    hideIcon: { required: false, type: Boolean, default: false },
    /** May be anything representing what's the entry is about */
    subject: { required: true, type: String },
    /** An icon representing what's the entry is about */
    subjectIcon: { required: true, type: String },
    /** Entry title */
    title: { required: false, type: String, default: null },
    /** Optional subject for which to load the comments */
    commentsSubject: { required: false, type: [Observation, Task], default: null },
    /** Whether to open entry on load */
    opened: { required: false, type: Boolean, default: false },
  },
  data () {
    return {
      showComments: this.opened,
      commentsShownOnce: this.opened,
    }
  },
  methods: {
    isSlotEmpty,
    toggleComments () {
      this.commentsShownOnce = true
      this.showComments = !this.showComments
    },
  },
}
</script>
